CodeForces

来源:互联网 发布:m audio 610驱动 mac 编辑:程序博客网 时间:2024/05/20 15:59

Some time ago Slastyona the Sweetmaid decided to open her own bakery! She bought required ingredients and a wonder-oven which can bake several types of cakes, and opened the bakery.

Soon the expenses started to overcome the income, so Slastyona decided to study the sweets market. She learned it’s profitable to pack cakes in boxes, and that the more distinct cake types a box contains (let’s denote this number as the value of the box), the higher price it has.

She needs to change the production technology! The problem is that the oven chooses the cake types on its own and Slastyona can’t affect it. However, she knows the types and order of n cakes the oven is going to bake today. Slastyona has to pack exactly k boxes with cakes today, and she has to put in each box several (at least one) cakes the oven produced one right after another (in other words, she has to put in a box a continuous segment of cakes).

Slastyona wants to maximize the total value of all boxes with cakes. Help her determine this maximum possible total value.

Input
The first line contains two integers n and k (1 ≤ n ≤ 35000, 1 ≤ k ≤ min(n, 50)) – the number of cakes and the number of boxes, respectively.

The second line contains n integers a1, a2, …, an (1 ≤ ai ≤ n) – the types of cakes in the order the oven bakes them.

Output
Print the only integer – the maximum total value of all boxes with cakes.

Example
Input
4 1
1 2 2 1
Output
2
Input
7 2
1 3 3 1 4 4 4
Output
5
Input
8 3
7 7 8 7 7 8 1 7
Output
6
Note
In the first example Slastyona has only one box. She has to put all cakes in it, so that there are two types of cakes in the box, so the value is equal to 2.

In the second example it is profitable to put the first two cakes in the first box, and all the rest in the second. There are two distinct types in the first box, and three in the second box then, so the total value is 5.

这个题首先掌握一个弱智的暴力n^2dp做法
然后加上线段树

这个线段树加的真鸡儿巧妙
首先枚举分块次数

然后对于每个次数
每种数不可能贡献超过分块次数的值

然后只有覆盖的区间内才享有贡献值
对于dp数组每一层只用一次线段树

每次用线段树覆盖前面相当于一个
dp+w()的比较
取最大的就是要更新的

因为前面都是更新好了的
所以后面不用更新了…

#include<cstdio>  #include<algorithm>  #include<iostream>#include<cstring>  using namespace std;struct p{    int z, y, c,l;};p shu[300000];int dp[300000],tu[300000];void jianshu(int gen, int z, int y){    shu[gen].z = z;    shu[gen].y = y;    shu[gen].l = shu[gen].c = 0;    if (z == y)    {        shu[gen].c = dp[z];        return;    }    int mid = (z + y) / 2;    jianshu(2 * gen, z, mid);    jianshu(2 * gen + 1, mid + 1, y);    shu[gen].c = max(shu[2 * gen].c, shu[2 * gen + 1].c);}void gengxin(int gen, int z, int y, int l, int r,int zhi){    if (z > r||y<l)return;    if (z >= l&&y <= r)    {        shu[gen].c += zhi;        shu[gen].l += zhi;        return;    }    int mid = (z + y) / 2;    shu[2 * gen].c += shu[gen].l;    shu[2 * gen + 1].c += shu[gen].l;    shu[2 * gen].l += shu[gen].l;    shu[2 * gen + 1].l += shu[gen].l;    shu[gen].l = 0;    gengxin(2 * gen, z, mid, l, r, zhi);    gengxin(2 * gen + 1, mid + 1, y, l, r, zhi);    shu[gen].c = max(shu[gen*2].c, shu[gen * 2 + 1].c);}int wen(int gen, int z, int y, int l, int r){    if (z > r || y < l)return 0;    if (z >= l&&y <= r)return shu[gen].c;    int mid = (z + y) / 2;    shu[2 * gen].c += shu[gen].l;    shu[2 * gen+1].c += shu[gen].l;    shu[2 * gen].l += shu[gen].l;    shu[2 * gen+1].l += shu[gen].l;    shu[gen].l = 0;    return max(wen(2 * gen, z, mid, l, r), wen(2 * gen + 1, mid + 1, y, l, r));}int zj[360000],sg[360000];int main(){    int n, m;    cin >> n >> m;    for (int a = 1; a <= n; a++)scanf("%d", &tu[a]);    for (int a = 1; a <= n; a++)    {        sg[a] = zj[tu[a]];        zj[tu[a]] = a;    }//  for (int a = 1; a <= n; a++)cout << sg[a] << " ";    //return 0;    for (int a = 1; a <= m; a++)    {        jianshu(1, 0, n);    //  for (int c = 0; c <= n; c++)cout << dp[c] << " ";    //  cout << endl;        for (int b = 1; b <= n; b++)        {            gengxin(1, 0, n, sg[b], b - 1, 1);            dp[b] = wen(1, 0, n, 0, b-1);        }    //  for (int c = 0; c <= n; c++)cout << wen(1, 0, n, c, c) << " ";//      cout << endl;//    }    printf("%d\n", dp[n]);}
原创粉丝点击